From eb0a349fa0da00eee9556ae02e5e69958d4b9d50 Mon Sep 17 00:00:00 2001
From: Tom Cosgrove <tom.cosgrove@arm.com>
Date: Tue, 2 Apr 2024 14:26:13 +0100
Subject: [PATCH] Fix compilation of ssl_tls13_generic.c when memcpy()
 is a function-like macro

Fixes #8994

Signed-off-by: Tom Cosgrove <tom.cosgrove@arm.com>
---
 .../fix-compilation-when-memcpy-is-function-like-macro.txt  | 2 ++
 library/ssl_tls13_generic.c                                 | 6 ++++--
 2 files changed, 6 insertions(+), 2 deletions(-)
 create mode 100644 ChangeLog.d/fix-compilation-when-memcpy-is-function-like-macro.txt

diff --git ChangeLog.d/fix-compilation-when-memcpy-is-function-like-macro.txt ChangeLog.d/fix-compilation-when-memcpy-is-function-like-macro.txt
new file mode 100644
index 000000000..11e7d2539
--- /dev/null
+++ ChangeLog.d/fix-compilation-when-memcpy-is-function-like-macro.txt
@@ -0,0 +1,2 @@
+Bugfix
+   * Fix compilation error when memcpy() is a function-like macros. Fixes #8994.
diff --git library/ssl_tls13_generic.c library/ssl_tls13_generic.c
index d448a054a..3be6db78f 100644
--- library/ssl_tls13_generic.c
+++ library/ssl_tls13_generic.c
@@ -193,10 +193,12 @@ static void ssl_tls13_create_verify_structure(const unsigned char *transcript_ha
     idx = 64;
 
     if (from == MBEDTLS_SSL_IS_CLIENT) {
-        memcpy(verify_buffer + idx, MBEDTLS_SSL_TLS1_3_LBL_WITH_LEN(client_cv));
+        memcpy(verify_buffer + idx, mbedtls_ssl_tls13_labels.client_cv,
+               MBEDTLS_SSL_TLS1_3_LBL_LEN(client_cv));
         idx += MBEDTLS_SSL_TLS1_3_LBL_LEN(client_cv);
     } else { /* from == MBEDTLS_SSL_IS_SERVER */
-        memcpy(verify_buffer + idx, MBEDTLS_SSL_TLS1_3_LBL_WITH_LEN(server_cv));
+        memcpy(verify_buffer + idx, mbedtls_ssl_tls13_labels.server_cv,
+               MBEDTLS_SSL_TLS1_3_LBL_LEN(server_cv));
         idx += MBEDTLS_SSL_TLS1_3_LBL_LEN(server_cv);
     }
 
